---
layout: article
title: Beautiful Canoe | Research software engineering and maintenance
headline: Research Software Engineering
description: If you have research software that needs maintaining, refactoring or repackaging then Beautiful Canoe can help! With an excellent track record in research software engineering, you won't be disappointed.
og-image: images/portfolio/traffic3d-site.png
og-image-type: image/png
og-image-width: 500
og-image-height: 370
og-image-alt: Traffic3D project website - created for a Beautiful Canoe client
slug: research-software-engineering.html
navigation_weight: 5
nav:
    - title: Why Beautiful Canoe?
      url: "#intro"
    - title: "Portfolio: Text Crimes"
      url: "#portfolio1"
    - title: "Portfolio: Traffic3D"
      url: "#portfolio2"
    - title: Interested?
      url: "#interested"
---
    <section id="intro" class="container-fluid center padded">
        <div class="row">
            <div class="col-xs-12 col-sm-10 col-sm-offset-1 col-md-8 col-md-offset-2">
                <p class="home__text">
                    <strong>Beautiful Canoe can provide the software engineering expertise that your group needs to make your research software sustainable.</strong>
                </p>
                <p class="home__text">
                    Software is a key part of research in all disciplines, and research software is often written under considerable pressure for time and resources.
                    Increasingly, both Universities and funding bodies are realising that research software needs to be supported by engineers who are trained in software development.
                    The momentum behind this culture change has been supported by organisations such as the <a href="https://software.ac.uk">Software Sustainability Institute</a> and the <a href="https://rse.ac.uk/">UK Research Software Engineer Association.</a>
                    Whether you have existing research software that needs to be sustainable for your next generation of collaborators, or you need a piece of software written from scratch, Beautiful Canoe can help.
                </p>
            </div>
        </div>
        <div class="row">
            <div class="col-xs-12 col-sm-10 col-sm-offset-1 col-md-8 col-md-offset-2">
                <h2>Why Beautiful Canoe?</h2>
                <span class="line"></span>
                <p class="home__text">
                    Beautiful Canoe has a wealth of experience in agile software development, and can help your research team to ensure that your software is reusable and sustainable.
                    In particular, we can offer help with:
                </p>
                <ul class="justify">
                    <li>Dependency management and ensuring that your code will work for your collaborators;</li>
                    <li>archiving versions of your software with a <a href="https://www.doi.org/">DOI</a>, so that other researchers can cite specific versions of your software;</li>
                    <li>refactoring and testing your software, and</li>
                    <li>documenting your software for both users and collaborators.</li>
                </ul>
            </div>
        </div>
    </section>
    <section id="portfolio1" class="container-fluid center padded">
        <div class="row">
            <div class="col-xs-12 col-sm-10 col-sm-offset-1 col-md-8 col-md-offset-2">
                <h2>Portfolio: Text Crimes</h2>
                <span class="line"></span>
                <p class="home__text">
                    <a href="https://textcrimes.com">Text Crimes</a> is an online database that Beautiful Canoe implemented for <a href="https://www2.aston.ac.uk/lss/staff-directory/grantt">Professor Tim Grant</a> at the <a href="http://www.forensiclinguistics.net/">Centre for Forensic Linguistics</a>, at <a href="https://aston.ac.uk">Aston University</a>.
                    The <a href="https://textcrimes.com">Text Crimes</a> website contains a database of curated malicious communications, designed to create a common set of corpora for forensic linguistic researchers.
                    As well as storing the text of malicious communications, <a href="https://textcrimes.com">Text Crimes</a> allows researchers to run a small number of common, automated, <a href="https://en.wikipedia.org/wiki/Natural_language_processing">NLP</a> algorithms over the curated corpora.
                </p>
            </div>
        </div>
    </section>
    <section id="portfolio2" class="container-fluid center padded">
        <div class="row">
            <div class="col-xs-12 col-sm-10 col-sm-offset-1 col-md-8 col-md-offset-2">
                <h2>Portfolio: Traffic 3D</h2>
                <span class="line"></span>
                <p class="home__text">
                    The <a href="https://traffic3d.org">Traffic3D project</a> started as the software component of Dr Deepeka Garg's PhD work, supervised by <a href="https://www2.aston.ac.uk/eas/staff/a-z/dr-maria-chli/index">Dr Maria Chli</a>.
                    Beautiful Canoe was able to add tests to the software, refactor and document it, and create a <a href="https://gitlab.com/traffic3d/traffic3d">public repository</a> for the code.
                    We also created a <a href="https://gitlab.com/traffic3d/traffic3d/blob/main/CITATION">citeable DOI</a> for the first public release of the software, and <a href="https://traffic3d.org">a project website</a>.
                </p>
                <div class="home__text center">
                    <figure>
                        <a href="https://traffic3d.org"><img src="images/portfolio/traffic3d-site.png" class="responsive500" alt="Traffic3D project website." width=500 /></a>
                    </figure>
                </div>
            </div>
        </div>
    </section>
